// FileChangeEvent.h: interface for the CFileChangeEvent class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FILECHANGEEVENT_H__1B890621_FEC8_11D2_B9E0_704B7C000000__INCLUDED_)
#define AFX_FILECHANGEEVENT_H__1B890621_FEC8_11D2_B9E0_704B7C000000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



#include <string>
#include <map>
#include <vector>

class CFileInfo;

class CFilePath
{
public:
	CFilePath(const std::string &sPath) { m_sName = sPath;m_nCount = 0; }
	inline std::string getName(void) const { return m_sName; }
	inline void operator++(int) { m_nCount++; }
	inline void operator--(int) { m_nCount--; }
	inline int getCount(void) { return m_nCount; }
protected :
	std::string m_sName;
	int m_nCount;
};

typedef std::map<std::string, CFileInfo *> FileInfoMap;
typedef std::vector<CFilePath *> FilePathVector;

  
class CFileChangeEvent  
{
public:
	enum FileAlarm { FA_CHANGED, FA_REMOVED };
	CFileChangeEvent();
	virtual ~CFileChangeEvent();
	void addFile(const std::string &sFileName);
	void removeFile(const std::string &sFileName);
	void startWatch(void);
	void stopWatch(void);
	inline bool isWatching(void) const { return m_bEvent; }

protected:
	virtual void OnFileAlarm(FileAlarm nAlarm, const std::string &sFileName) {}	
  HANDLE m_hThread;
  HANDLE m_hWatchEvent;
  HANDLE m_hThreadTermEvent;
  DWORD m_dwThreadID;
	FileInfoMap m_FileInfoMap;
	FilePathVector m_Paths;
	bool m_bEvent;

  static DWORD WINAPI FileChangeWatch(LPVOID lpParameter);
};

#endif // !defined(AFX_FILECHANGEEVENT_H__1B890621_FEC8_11D2_B9E0_704B7C000000__INCLUDED_)
