// FileInfo.h: interface for the CFileInfo class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FILEINFO_H__1B890622_FEC8_11D2_B9E0_704B7C000000__INCLUDED_)
#define AFX_FILEINFO_H__1B890622_FEC8_11D2_B9E0_704B7C000000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>

class CFileInfo  
{
public:
	CFileInfo(const std::string &sName);
	virtual ~CFileInfo();
	inline std::string getName(void) const { return m_sName; }
	inline std::string getPath(void) const { return m_sPath; }
	inline FILETIME getDate(void) const { return m_dtFileDate; }
	inline void setDate(const FILETIME &dtDate) 
  { 
    m_dtFileDate.dwLowDateTime = dtDate.dwLowDateTime;
    m_dtFileDate.dwHighDateTime = dtDate.dwHighDateTime;
  }
protected:
	std::string m_sName;
	std::string m_sPath;
	FILETIME m_dtFileDate;
};

#endif // !defined(AFX_FILEINFO_H__1B890622_FEC8_11D2_B9E0_704B7C000000__INCLUDED_)
