/*
  Copyright (C) 1998-1999 Johan Redestig

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "stdafx.h"
#include "PopupMaker.h"
#include "Popup.h"
#include "PopupMenu.h"
#include "../lsapi/lsapi.h"
#include <crtdbg.h>

PopupMaker* pPopupMaker;

int initModule(HWND ParentWnd, HINSTANCE dllInst, wharfDataType* wd)
{
	return initModuleEx (ParentWnd, dllInst, wd->lsPath);
}

int initModuleEx(HWND ParentWnd, HINSTANCE dllInst, LPCSTR szPath)
{    
	pPopupMaker = new PopupMaker();

	pPopupMaker->Initialize(ParentWnd, dllInst, szPath);
	return 0;
}

int quitModule(HINSTANCE dllInst)
{
// ryan dalzell
	for(int i=0; i<pPopupMaker->m_RootMenus.size(); i++)
		RemoveBangCommand(pPopupMaker->m_RootMenus.at(i)->GetBangName());
	delete pPopupMaker;
	_ASSERTE(_CrtCheckMemory());
	return 1;
}

// ryan dalzell
// Function for Litestep to call to implement all Popup bang commands
void BangCommand(HWND hCaller, char *pszCommandName, char *pszArgs)
{
	for(int i=0; i<pPopupMaker->m_RootMenus.size(); i++)
	{
		PopupMenu* pRootMenu = (pPopupMaker->m_RootMenus).at(i);
		if(!lstrcmpi(pszCommandName, pRootMenu->GetBangName()))
			pPopupMaker->Show(i);
	}
}
//

BOOL WINAPI DllMain(HINSTANCE hInstDLL, DWORD dwReason, LPVOID lpvReserved)
{
	switch( dwReason )
	{
		case DLL_PROCESS_ATTACH:
    {
			DisableThreadLibraryCalls(hInstDLL);
			return (1);
    }
    break;

    default:
    {
      return (1);
    }
	}
}


/* THIS IS VERY VERY BAD !!!!!!!!!!!

    The runtime fails to initialise properly with this call....
    DisableThreadLibraryCalls has been moved above (to its proper place :-))



// Dummy startup routine that does almost nothing.
// This cuts out all of the standard startup code crud that
// bloats the DLL, and makes it take longer to load
BOOL __stdcall _DllMainCRTStartup(HINSTANCE hInst, DWORD fdwReason, LPVOID lpvRes)
{
     // We don't need thread notifications for what we're doing.  Thus, get
     // rid of them, thereby eliminating some of the overhead of this DLL
     DisableThreadLibraryCalls(hInst);
	 
	 return TRUE;
}
*/
